#ifndef _FMPLL_H_
#define _FMPLL_H_

#include "MPC5634M.h"

#define SYSCLK 80000000

/**
 *
 *  @brief  Set the system clock to 80 MHz
 *
 *  @param[out]  none
 *                                               
 *
 *  @retval void
 *  
 */
extern void sysclk_init(void);


/**
 *
 *  @brief  Initialize the WDT to expire at desired Time out
 *
 *  @param[in] Time out in ms
 *                                               
 *
 *  @retval void
 *  
 */
extern void Watchdog_init(uint32_t to_ms);

/**
 *
 *  @brief  Feeds the WDT
 *
 *  @param[out]  none
 *                                               
 *
 *  @retval void
 *  
 */

extern void Watchdog_feed(void);

#endif
