#ifndef stm_h
#define stm_h

#include "MPC5634M.h"
//#include "Common_def.h"

#define STM_CLK_MHZ 80U

extern vint8_t STM1_expired;

/*
extern vuint32_t Tick_10us;

extern vuint32_t stm0_cmp,stm1_cmp,stm2_cmp,stm3_cmp;
*/

/**
 *
 *  @brief  Initialise the System Timer module to configure the operating frequency 
 *
 *  @param[in] Frequency of STM to be configured
 *                                               
 *
 *  @retval void
 *  
 */
extern void stm_init(uint8_t freq_MHz);

/**
 *
 *  @brief  Enables the System Timer module Channel 0 
 *
 *  @param[in] count value to be loaded to compare register
 *                                               
 *
 *  @retval void
 *  
 */
extern void stm_ch0_config(uint32_t count);

/**
 *
 *  @brief  Enables the System Timer module Channel 1 
 *
 *  @param[in] count value to be loaded to compare register
 *                                               
 *
 *  @retval void
 *  
 */
extern void stm_ch1_config(uint32_t count);

/**
 *
 *  @brief  Enables the System Timer module Channel 2 
 *
 *  @param[in] count value to be loaded to compare register
 *                                               
 *
 *  @retval void
 *  
 */
extern void stm_ch2_config(uint32_t count);

/**
 *
 *  @brief  Enables the System Timer module Channel 3
 *
 *  @param[in] count value to be loaded to compare register
 *                                               
 *
 *  @retval void
 *  
 */
extern void stm_ch3_config(uint32_t count);

/**
 *
 *  @brief  Enables the System Timer module to run  
 *
 *  @param[in] none
 *                                               
 *
 *  @retval void
 *  
 */
extern void stm_enable(void);

/**
 *
 *  @brief  Interrupt service routine for STM channel 0
 *
 *  @param[in] none
 *                                               
 *
 *  @retval void
 *  
 */
extern void stm_0_ISR(void);

/**
 *
 *  @brief  Interrupt service routine for STM channel 1
 *
 *  @param[in] none
 *                                               
 *
 *  @retval void
 *  
 */
extern void stm_1_ISR(void);
/**
 *
 *  @brief  Interrupt service routine for STM channel 2
 *
 *  @param[in] none
 *                                               
 *
 *  @retval void
 *  
 */
extern void stm_2_ISR(void);

/**
 *
 *  @brief  Interrupt service routine for STM channel 3
 *
 *  @param[in] none
 *                                               
 *
 *  @retval void
 *  
 */
extern void stm_3_ISR(void);

/**
 *
 *  @brief  Function to return the number of STM 0 interrupt counts
 *
 *  @param[in] none
 *                                               
 *
 *  @retval ISR channel 0 count
 *  
 */
extern uint32_t stm_0_count(void);
extern void stm_ch_disable(uint8_t ch);




#endif
