#include "fmpll.h"

void sysclk_init(void)
{
#if (SYSCLK!=80000000)
#error	system clock wrong
#endif
	/* Set PLL0 */

	/*
	fref=8MHz
	fsys =fref*(MFD + 4)/((PREDIV + 1)*2^RFD)

	fVCO = 4 * fsys * 2^RFD
	 */
	FMPLL.ESYNCR1.B.CLKCFG  =  7U;      /* Switch clk to PLL normal mode from crystal */
	/*
	PREDIV = 1,MFD = 16,RFD = 1
	 */
	FMPLL.SYNCR.R = 0x18080000UL; 

	while (FMPLL.SYNSR.B.LOCK != 1U) 
	{  ;
	};	/* Wait for PLL lock */


	FMPLL.SYNCR.R = 0x18000000UL;
	/*
	PREDIV = 1,MFD = 16,RFD = 0
	fsys=80MHz
	 */
}

void Watchdog_init(uint32_t to_ms)
{
	uint32_t TO_val;
	/*To clear the soft lock, sequence 0xC520 and 0xD928 is written one after other to the service register. */
	SWT.SR.B.WSC= 0xC520;
	SWT.SR.B.WSC= 0xD928; 
	
	/*Timeout value, if it is lower than 0x100 defaults to 0x100
	 * Oscillator clk time period =1/8MHz = 0.125us =0.000125ms
	 * for 1ms timeout*/
	TO_val = 8000U * to_ms; /*(1/0.000125 = 8000)*/
	SWT.TO.R= TO_val;
	
	
	/*Access enabled to all masters
	 * KEY -0 ; fixed sequence to service WD
	 * RIA-1; invalid access to SWT causes reset with WEN=1
	 * CSL -1 : Osc clk is selected (8 MHz)
	 * FRZ -0 :Run in debug
	 * WEN -1 : SWT is enabled*/
	SWT.MCR.R= 0xFF000109UL; 
}

void Watchdog_feed(void)
{
	/*Fixed sequence to be written to feed the WDT*/
	
	SWT.SR.B.WSC= 0xA602;
	SWT.SR.B.WSC=0xB480;
	
}
