#include "stm.h"


#define systemclk_MHz   80U
 
vint8_t STM1_expired=1;

vuint32_t stm0_cmp=0U;
vuint32_t Tick_10us=0U;


void stm_init(uint8_t freq_MHz)
{
  /*(min: 313 KHZ , scaler-256)*/
	
	vuint32_t clk_freq;
	
	clk_freq = (vuint32_t)systemclk_MHz/freq_MHz; /* Clock divider value (0-255)*/
	
	STM.CR.B.CPS=(clk_freq-1U);


	STM.CR.B.FRZ=1U; /*Stop in debug mode */
}

void stm_ch0_config(uint32_t count)
{
	
	STM.CMP0.R=count;   /* load the counter value for match*/
	stm0_cmp= STM.CMP0.R;
	STM.CCR0.B.CEN=1U;	/*channel is enabled*/
	
}



void stm_enable(void)
{
	STM.CR.B.TEN=1U;  /* enable timer*/
}


void stm_0_ISR(void) /*isr takes about 1us*/
{
	vuint32_t count_val;
	
	Tick_10us ++;  
	
	count_val = STM.CNT.R;
	
	STM.CMP0.R=count_val+stm0_cmp; /* Load the new compare match value*/

	STM.CIR0.B.CIF=1U;  /* Clear the channel interrupt by writing 1*/
	
}

uint32_t stm_0_count(void)
{
	return (uint32_t)Tick_10us;
}

